#!/usr/bin/tclsh 

set DIR_DEVICE PH1A100SFG676_Test

set DEVICE_TARGET PH1A100SFG676  

set file_name "PH1A100SFG676_devicechaintest.log" 
set ffile_name [ file exists $file_name ]
puts $ffile_name
if { ${ffile_name} == 1 }    {
     file delete -force $file_name 
    set fp [open $file_name a]
    } else {
    set fp [open $file_name a]
    }

#set curtime [clock format [clock seconds]]
set curtime  [clock seconds]

set MSPI_X1  "./$DIR_DEVICE/MSPIX1.bit"
set MSPI_X2  "./$DIR_DEVICE/MSPIX2.bit"
set MSPI_X4  "./$DIR_DEVICE/MSPIX4.bit"

set MSPI_X4_BIN  "./$DIR_DEVICE/MSPIX4.bin"
set READHEX_BIN  "./$DIR_DEVICE/readhex.bin"

set DUALBOOT_PRIMARY  "./$DIR_DEVICE/mergbit_primary.bin"
set DUALBOOT_GOLDEN   "./$DIR_DEVICE/mergbit_golden.bin"
 
set DONECHECK  "./$DIR_DEVICE/checkdone.svf"
set BIT_FILE   "./$DIR_DEVICE/MSPIX4.bit"
set SVF_DIR    "./$DIR_DEVICE/device_chain"

set SRAM_FILE_PREFIX sram_svf
set DONE_FILE_PREFIX checkdone_svf
set ERASE_SRAM_PREFIX erase_sram_svf
set SECTOR_ERASE_PERFIX   sector_erase_svf
set REFRESH_PREFIX rfresh_svf
set SPI_FLASH_PREFIX spi_flash_svf
set CHECKID_PERFIX checkid_svf
set MERGE_SPI_FLASH "./$SVF_DIR/merge_spi_L123.svf"
set MERGE_CHECKDONE "./$SVF_DIR/merge_done_L123.svf"
set WAIT_TIME 20000
file mkdir $SVF_DIR
puts $fp "$DEVICE_TARGET Device Chain Test ......................"
puts $fp "Running Time (From 1970 - 1 - 1 Now :): $curtime Seconds"

puts $fp "Create All Device Chain************************************************"
#Create SRAM SVF File////////////////////////////////////////////////////////////////////////////////// 
#3 level device chain , verify, enable / disable TIR/HIR/~
set erase_flag1 0
set erase_flag2 0
set erase_flag3 0
set erase_flag1 [catch { svfgen -scan_mode prog_sram -level 1 -bit  $BIT_FILE -svf $SVF_DIR/${SRAM_FILE_PREFIX}_L1.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -verify -dis_hir_hdr_tir_tdr}] 
set erase_flag2 [catch { svfgen -scan_mode prog_sram -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${SRAM_FILE_PREFIX}_L2.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -verify -dis_hir_hdr_tir_tdr}]                         
set erase_flag3 [catch { svfgen -scan_mode prog_sram -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${SRAM_FILE_PREFIX}_L3.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -verify}]   

puts $fp "Create SRAM SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level -verify disable tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "1-Level -verify disable tir/hir...  : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level -verify disable tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "2-Level -verify disable tir/hir...  : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level -verify enable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level -verify enable  tir/hir...  : Device Chain Generated SVF File Success"
    }
 
#Create DONE SVF File////////////////////////////////////////////////////////////////////////////////// 
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode check_status_done -level 1 -bit $BIT_FILE -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L1.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]    
 
set erase_flag2 [catch { svfgen -scan_mode check_status_done -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L2.svf \
                        -opt comment -bypass 11111111_11111111_11111111}]    
 
set erase_flag3 [catch { svfgen -scan_mode check_status_done -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L3.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]  


puts $fp "Create DONE SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Success"
    } else {  
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Success"
    } else {   
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    }
#Create Erase SRAM SVF File////////////////////////////////////////////////////////////////////////////////// 
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode erase_sram -level 1 -bit $BIT_FILE -svf  $SVF_DIR/${ERASE_SRAM_PREFIX}_L1.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]    
 
set erase_flag2 [catch { svfgen -scan_mode erase_sram -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${ERASE_SRAM_PREFIX}_L2.svf \
                        -opt comment -bypass 11111111_11111111_11111111}]    
 
set erase_flag3 [catch { svfgen -scan_mode erase_sram -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${ERASE_SRAM_PREFIX}_L3.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]  

puts $fp "Create Erase SRAM SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Success"
    } else {  
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Success"
    } else {   
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    }
#Create Refresh SVF File////////////////////////////////////////////////////////////////////////////////// 
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode refresh -level 1 -bit $BIT_FILE -svf  $SVF_DIR/${REFRESH_PREFIX}_L1.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]    
 
set erase_flag2 [catch { svfgen -scan_mode refresh -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${REFRESH_PREFIX}_L2.svf \
                        -opt comment -bypass 11111111_11111111_11111111}]    
 
set erase_flag3 [catch { svfgen -scan_mode refresh -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${REFRESH_PREFIX}_L3.svf \
                        -opt comment -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr}]  


puts $fp "Create Refresh SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Success"
    } else {  
    puts $fp "1-Level disable tir/hir...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Success"
    } else {   
    puts $fp "2-Level enable tir/hir...    : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level disable  tir/hir...  : Device Chain Generated SVF File Success"
    }
#Create SPI FLASH SVF File//////////////////////////////////////////////////////////////////////////////////     
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode prog_spi -level 1 -bit $BIT_FILE -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L1.svf \
                       -opt comment -tool tde -bg_mode yes -len_mode normal -flashsize 128  -rf_mode yes \
                       -bypass 11111111_11111111_11111111 -verify -freq 1MHz }]      

set erase_flag2 [catch { svfgen -scan_mode prog_spi -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L2.svf \
                       -opt no_comment -tool tde -bg_mode no -len_mode short -flashsize 128  -rf_mode yes \
                       -bypass 11111111_11111111_11111111 -verify -freq 1MHz }]  

set erase_flag3 [catch { svfgen -scan_mode prog_spi -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L3.svf \
                       -opt comment -tool tde -bg_mode yes -len_mode normal -flashsize 128  -rf_mode yes \
                       -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr }]  

puts $fp "Create SPI FLASH SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level -bg_mode yes -len_mode normal -rf_mode yes...                   : Device Chain Generated SVF File Success"
    } else {                                 
    puts $fp "1-Level -bg_mode yes -len_mode normal -rf_mode yes...                   : Device Chain Generated SVF File Error"
    }               
if  { ${erase_flag2} == 0 } {               
    puts $fp "2-Level -bg_mode no -len_mode short -rf_mode yes  ...                   : Device Chain Generated SVF File Success"
    } else {                                   
    puts $fp "2-Level -bg_mode no -len_mode short -rf_mode yes  ...                   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level -bg_mode yes -len_mode normal -rf_mode yes disable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level -bg_mode yes -len_mode normal -rf_mode yes disable  tir/hir...  : Device Chain Generated SVF File Success"
    }
#Create ERASE 4K SVF File//////////////////////////////////////////////////////////////////////////////////     
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode sector_erase_4k -level 1 -bit $BIT_FILE -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L1.svf \
                       -opt comment -tool tde \
                       -bypass 11111111_11111111_11111111 -freq 1MHz -bg_mode  yes}]      

set erase_flag2 [catch { svfgen -scan_mode sector_erase_4k -level 2 -bit $BIT_FILE -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L2.svf \
                       -opt comment -tool tde \
                       -bypass 11111111_11111111_11111111 -freq 1MHz -bg_mode yes}]    

set erase_flag3 [catch { svfgen -scan_mode sector_erase_4k -level 3 -bit $BIT_FILE -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L3.svf \
                       -opt comment -tool tde \
                       -bypass 11111111_11111111_11111111 -freq 1MHz -dis_hir_hdr_tir_tdr -bg_mode no }]                                                

puts $fp "Create ERASE 4K SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level -bg_mode  yes enable tir/hir...   : Device Chain Generated SVF File Success"
    } else {  
    puts $fp "1-Level -bg_mode  yes enable tir/hir...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level -bg_mode  yes enable tir/hir...   : Device Chain Generated SVF File Success"
    } else {   
    puts $fp "2-Level -bg_mode  yes enable tir/hir...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level -bg_mode  no disable  tir/hir...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level -bg_mode  no disable  tir/hir...  : Device Chain Generated SVF File Success"
    }

#Create CheckID SVF File////////////////////////////////////////////////////////////////////////////////// 
# 3 level device chain , comments, enable / disable TIR/HIR/~
set erase_flag1 [catch { svfgen -scan_mode id -level 1 -bit $BIT_FILE -total 3 -svf  $SVF_DIR/${CHECKID_PERFIX}_L1.svf \
                       -opt comment -bypass 11111111_11111111_11111111}]
                     

set erase_flag2 [catch { svfgen -scan_mode id -level 2 -bit $BIT_FILE -total 3  -svf  $SVF_DIR/${CHECKID_PERFIX}_L2.svf \
                       -opt comment -bypass 11111111_11111111_11111111}]
                      

set erase_flag3 [catch { svfgen -scan_mode id -level 3 -bit $BIT_FILE -total 3  -svf  $SVF_DIR/${CHECKID_PERFIX}_L3.svf \
                       -opt comment -bypass 11111111_11111111_11111111}]

puts $fp "Create CheckID SVF File Result : "
 
if  { ${erase_flag1} == 0 } {
    puts $fp "1-Level  ...   : Device Chain Generated SVF File Success"
    } else {  
    puts $fp "1-Level  ...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag2} == 0 } {
    puts $fp "2-Level  ...   : Device Chain Generated SVF File Success"
    } else {   
    puts $fp "2-Level  ...   : Device Chain Generated SVF File Error"
    }
if  { ${erase_flag3} == 0 } {
    puts $fp "3-Level  ...  : Device Chain Generated SVF File Success"
    } else { 
    puts $fp "3-Level  ...  : Device Chain Generated SVF File Success"
    }


#Create Merge SPI & DONE SVF File////////////////////////////////////////////////////////////////////////////////// 
set MERGE_SVF1 $SVF_DIR/${SPI_FLASH_PREFIX}_L1.svf
set MERGE_SVF2 $SVF_DIR/${SPI_FLASH_PREFIX}_L2.svf
set MERGE_SVF3 $SVF_DIR/${SPI_FLASH_PREFIX}_L3.svf
set merge_flag1 0
set merge_flag2 0
set merge_flag1 [catch { svfgen -svf $MERGE_SPI_FLASH -merge "$MERGE_SVF1 $MERGE_SVF2 $MERGE_SVF3"  }]

set MERGE_SVF1 $SVF_DIR/${DONE_FILE_PREFIX}_L1.svf
set MERGE_SVF2 $SVF_DIR/${DONE_FILE_PREFIX}_L2.svf
set MERGE_SVF3 $SVF_DIR/${DONE_FILE_PREFIX}_L3.svf

set merge_flag2 [catch { svfgen -svf $MERGE_CHECKDONE -merge "$MERGE_SVF1 $MERGE_SVF2 $MERGE_SVF3"  }]
puts $fp "Create Merge SPI & DONE SVF File Result : "
 
if  { ${merge_flag1} == 0 } {
    puts $fp "Device Chain Merged SPI 1/2/3 SVF File Success"
    } else {  
    puts $fp "Device Chain Merged SPI 1/2/3 SVF File Error"
    }
if  { ${merge_flag2} == 0 } {
    puts $fp "Device Chain Merged DONE 1/2/3 SVF File Success"
    } else {  
    puts $fp "Device Chain Merged DONE 1/2/3 SVF File Error"
    }

## #Create Merge SVF File////////////////////////////////////////////////////////////////////////////////// 
## set SVF1 $SVF_DIR/${SPI_FLASH_PREFIX}_L1.svf
## set SVF2 $SVF_DIR/${SPI_FLASH_PREFIX}_L2.svf
## set SVF3 $SVF_DIR/${SPI_FLASH_PREFIX}_L3.svf
## svfgen -svf $MERGE_SPI_FLASH -merge "./ef3_test/device_chain/spi_flash_svf_L1.svf" "./ef3_test/device_chain/spi_flash_svf_L1.svf"
 
  

#Program SRAM SVF File////////////////////////////////////////////////////////////////////////////////// 
set progam1 0
set progam2 0
set progam3 0
set checkdone1 0
set checkdone2 0
set checkdone3 0

set progam1 [catch { program_svf -svf  $SVF_DIR/${SRAM_FILE_PREFIX}_L1.svf -spd 6 -cable 0 }]
set progam2 [catch { program_svf -svf  $SVF_DIR/${SRAM_FILE_PREFIX}_L2.svf -spd 6 -cable 0 }]
set progam3 [catch { program_svf -svf  $SVF_DIR/${SRAM_FILE_PREFIX}_L3.svf -spd 6 -cable 0 }]
after $WAIT_TIME
set checkdone1  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L1.svf -spd 6 -cable 0 }]
set checkdone2  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L2.svf -spd 6 -cable 0 }]
set checkdone3  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L3.svf -spd 6 -cable 0 }]

puts $fp "Program SRAM SVF File Result :"
 
if  { ${progam1} == 0  && ${checkdone1} == 0} {
    puts $fp "Download ${SRAM_FILE_PREFIX}_L1.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SRAM_FILE_PREFIX}_L1.svf  ...   : Download Error"
    }
if  { ${progam2} == 0  && ${checkdone2} == 0} {
    puts $fp "Download ${SRAM_FILE_PREFIX}_L2.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SRAM_FILE_PREFIX}_L2.svf  ...   : Download Error"
    }
if  { ${progam3} == 0  && ${checkdone3} == 0} {
    puts $fp "Download ${SRAM_FILE_PREFIX}_L3.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SRAM_FILE_PREFIX}_L3.svf  ...   : Download Error"
    }  

 

#Program SPI FLASH SVF File////////////////////////////////////////////////////////////////////////////////// 
set progam1 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L1.svf -spd 6 -cable 0 }]
set progam2 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L2.svf -spd 6 -cable 0 }]
set progam3 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L3.svf -spd 6 -cable 0 }]
after $WAIT_TIME
set checkdone1  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L1.svf -spd 6 -cable 0 }]
set checkdone2  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L2.svf -spd 6 -cable 0 }]
set checkdone3  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L3.svf -spd 6 -cable 0 }]

puts $fp "Program SPI SVF File Result :"
 
if  { ${progam1} == 0  && ${checkdone1} == 0} {
    puts $fp "Download ${SPI_FLASH_PREFIX}_L1.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SPI_FLASH_PREFIX}_L1.svf  ...   : Download Error"
    }
if  { ${progam2} == 0  && ${checkdone2} == 0} {
    puts $fp "Download ${SPI_FLASH_PREFIX}_L2.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SPI_FLASH_PREFIX}_L2.svf  ...   : Download Error"
    }
if  { ${progam3} == 0  && ${checkdone3} == 0} {
    puts $fp "Download ${SPI_FLASH_PREFIX}_L3.svf  ...   : Download Success"
    } else {  
    puts $fp "Download ${SPI_FLASH_PREFIX}_L3.svf  ...   : Download Error"
    }  

#Erase 4K bg mode FLASH SVF File////////////////////////////////////////////////////////////////////////////////// 
set progam1 0
set progam2 0
set progam3 0

set erase1 0
set erase2 0
set erase3 0

set checkdone1 0
set checkdone2 0
set checkdone3 0

set progam1 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L1.svf -spd 6 -cable 0 }]
set progam2 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L2.svf -spd 6 -cable 0 }]
set progam3 [catch { program_svf -svf  $SVF_DIR/${SPI_FLASH_PREFIX}_L3.svf -spd 6 -cable 0 }]

set erase1 [catch { program_svf -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L1.svf -spd 6 -cable 0 }]
set erase2 [catch { program_svf -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L2.svf -spd 6 -cable 0 }]
set erase3 [catch { program_svf -svf  $SVF_DIR/${SECTOR_ERASE_PERFIX}_L3.svf -spd 6 -cable 0 }]
after $WAIT_TIME 
set checkdone1  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L1.svf -spd 6 -cable 0 }]
set checkdone2  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L2.svf -spd 6 -cable 0 }]
set checkdone3  [catch { program_svf -svf  $SVF_DIR/${DONE_FILE_PREFIX}_L3.svf -spd 6 -cable 0 }]


puts $fp "Program Erase 4K SVF File Result :"
 
if  { ${progam1} == 0  && ${erase1} == 0 && ${checkdone1} == 0} {
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L1.svf  bg mode =Yes ...   : Download Success"
    } else {  
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L1.svf  bg mode =Yes ...   : Download Error"
    }
if  { ${progam2} == 0  && ${erase2} == 0 && ${checkdone2} == 0} {
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L2.svf  bg mode =Yes ...   : Download Success"
    } else {  
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L2.svf  bg mode =Yes ...   : Download Error"
    }
if  { ${progam3} == 0  && ${erase3} == 0 && ${checkdone3} != 0} {
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L3.svf  bg mode =No  ...   : Download Success(CheckDone Error)"
    } else {  
    puts $fp "Download ${SECTOR_ERASE_PERFIX}_L3.svf  bg mode =No  ...   : Download Error"
    }  

close $fp